Overview
Utility blocks provide supporting functionality:- Log: Debug output and message logging
- Script: Custom JavaScript execution
- Plugin: Load custom plugin blocks
- Webhook: Send HTTP webhooks
- WebSocket: WebSocket communication
- FileSystem: File and folder operations
- RandomUserAgent: Generate realistic user agents
- RandomData: Generate random test data
- ClearCookies: Clear cookie jar
- Constants: Define constant values
- Dictionary: Key-value storage operations
- GenerateGUID: Generate UUIDs
- PhoneCountry: Extract country from phone numbers
Log
Output messages to the console for debugging.Settings
Message to log (supports variable interpolation)
Example
Webhook
Send HTTP webhook notifications.Settings
Webhook URL
HTTP method (GET, POST, PUT)
Custom headers as
[name, value] tuplesRequest body with variable interpolation
Content-Type header value
Custom cookies (one per line:
name=value)Example
WebSocket
Communicate via WebSocket connections.Settings
WebSocket URL (ws:// or wss://)
WebSocket action:
connect- Open connectionsend- Send messagereceive- Receive messageclose- Close connection
Message to send (for
send action)Variable name to store received data
Operation timeout
Example
FileSystem
Perform file and folder operations.Settings
File operation:
FileRead- Read file contentsFileWrite- Write fileFileAppend- Append to fileFileDelete- Delete fileFileExists- Check if file existsFileCopy- Copy fileFileMove- Move/rename fileFileReadBytes- Read as binaryFileWriteBytes- Write binary dataFileReadLines- Read as line arrayFileWriteLines- Write line arrayFileAppendLines- Append linesCreatePath- Create directoryFolderDelete- Delete directoryFolderExists- Check if folder existsGetFilesInFolder- List files
File or folder path
Destination path (for Copy/Move operations)
Content to write (for Write/Append operations)
Text encoding (utf8, ascii, etc.)
Variable name to store result
Capture as user-visible variable
Example
RandomUserAgent
Generate realistic user agent strings.Settings
Generation mode:
Random- Generate from browser databaseCustomList- Pick from custom list
Browser types to include in random generation
Platform types to include
Custom user agent list (one per line)
Variable name to store generated user agent
Capture as user-visible variable
Match TLS fingerprint to user agent (when using AzureTLS)
Example
RandomData
Generate random test data.Settings
Type of data to generate:
String- Random stringUuid- UUID v4Number- Random numberEmail- Random email addressFirstName- Random first nameLastName- Random last nameFullName- Random full nameStreetAddress- Random addressCity- Random cityState- Random state/provinceZipCode- Random ZIP/postal codePhoneNumber- Random phone numberDate- Random date
Variable name to store generated value
Capture as user-visible variable
String length (for String type)
Character set:
alphanumeric, alpha, numeric, hex, customCustom character set (when charset is “custom”)
Minimum number (for Number type)
Maximum number (for Number type)
Generate decimal numbers
Date format string (for Date type)
Minimum date
Maximum date
Examples
Plugin
Load and execute custom plugin blocks.Settings
Name of the plugin block type to execute
JSON settings for the plugin (as string)
Variable name to store plugin output
Capture as user-visible variable
Example
Constants
Define constant values used throughout the pipeline.Settings
Array of constant entries with
name and valueExample
Dictionary
Perform key-value storage operations.Settings
Dictionary operation:
Get- Get value by keySet- Set key-value pairRemove- Remove keyExists- Check if key existsKeys- Get all keysValues- Get all values
Variable containing dictionary
Dictionary key
Value to set (for Set operation)
Variable name to store result
Capture as user-visible variable
GenerateGUID
Generate UUID/GUID values.Settings
UUID version:
V1- Time-basedV4- RandomV5- Name-based (SHA-1)
Namespace UUID (for V5)
Name string (for V5)
Variable name to store UUID
Capture as user-visible variable
Example
PhoneCountry
Extract country information from phone numbers.Settings
Variable containing phone number
Variable name to store result
Output format:
CountryCode- Numeric code (e.g., “1”)CountryName- Full name (e.g., “United States”)ISO2- 2-letter code (e.g., “US”)ISO3- 3-letter code (e.g., “USA”)
Capture as user-visible variable